﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace example
{
    public partial class Form1 : Form
    {
        /////////////////////////////////////////////////////////////////////////////
        [DllImport("pdftojpeg", CallingConvention = CallingConvention.StdCall)]
        public static extern int MLoad(string filename,string password);

        [DllImport("pdftojpeg", CallingConvention = CallingConvention.StdCall)]
        public static extern int MEncode(int id,int pageno);

        [DllImport("pdftojpeg", CallingConvention = CallingConvention.StdCall)]
        public static extern int MFree(int id);

        [DllImport("pdftojpeg", CallingConvention = CallingConvention.StdCall)]
        public static extern int MGetCount(int id);

        [DllImport("pdftojpeg", CallingConvention = CallingConvention.StdCall)]
        public static extern int MSetParam( int id,string outpath,int imagetype,int bitcount,
								          int quality,int grayscale,int rotate,int width,int height,int xdpi,int ydpi);

        /////////////////////////////////////////////////////////////////////////////
        const int IMAGE_FORMAT_JPG = 1;
        const int IMAGE_FORMAT_JP2 = 2;
        const int IMAGE_FORMAT_JPC = 3;
   
        
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int id = MLoad("test.pdf", "");
            if (id == -1)
            {
                MessageBox.Show("PDF file unexist or damaged!");
                return;
            }
            if (id == -2)
            {
                MessageBox.Show("PDF file is restricted!");
                return;
            }

            MSetParam(id, "", IMAGE_FORMAT_JPG, 24, 75, 0, 0, 0, 0, 96, 96);

            int pageCount = MGetCount(id);
            for (int i = 1; i <= pageCount; i++)
            {
                MEncode(id, i);
                progressBar1.Value = i * 100 / pageCount;
            }
            MFree(id);

            MessageBox.Show("Convert finished!");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int id = MLoad("test.pdf", "");
            if (id == -1)
            {
                MessageBox.Show("PDF file unexist or damaged!");
                return;
            }
            if (id == -2)
            {
                MessageBox.Show("PDF file is restricted!");
                return;
            }

            MSetParam(id, "", IMAGE_FORMAT_JP2, 24, 75, 0, 90, 800, 600, 120, 120);

            int pageCount = MGetCount(id);
            for (int i = 1; i <= pageCount; i++)
            {
                MEncode(id, i);
                progressBar1.Value = i * 100 / pageCount;
            }
            MFree(id);

            MessageBox.Show("Convert finished!");
        }
    }
}
